from . import bl_info
from .__variant__ import __VARIANT__, __IS_DEV__
from .weight_layers_addon.WL_constants import LAYER_TYPES

VARIANT = __VARIANT__
# used for setting defaults specific to my file system
IS_DEV = __IS_DEV__

# used to check if a node tree can be updated
# incremented when a breaking change is made.
ADDON_VERSION = bl_info["version"]
MAT_VERSION = (1, 0, 0)
GEO_NODES_VERSION = (1, 0, 0)
MOD_GROUP_VERSION = (1, 0, 0)
SAVED_BIOME_VERSION = (1, 1, 0)
TREE_OBJ_VERSION = (1, 0, 0)
TREE_METADATA_VERSION = (1, 0, 0)

DOCS_URL = "https://sites.google.com/view/alphatreesdocs"

AT_BLEND_NAME = "base_scene.blend"
AT_MAT_NAME = "AT_base_material"
AT_CAM_NAME = "AT_camera"
AT_WORLD_NAME = "AT_world"
AT_PREV_WORLD_NAME = "AT_preview_world"
AT_VGROUP_NAME = "AT_VGroup"

# provides a single reference for names, that can be changed easily,
# without having to search through a bunch of files for all references
NODE_NAMES = {
    "slot": "AT_GEO_BSETTINGS",
    "control": "AT_geo_settings_control",
    "wind": "AT_wind",
    "join": "at_join_geometry",
    # trees
    "tree": "AT_GEO_TREE",
    # single trees
    "single_tree": "AT_GEO_SINGLE_TREE",
    # material
    "mat_control": "Alpha trees control",
    "leaf_col": "leaf color",
    "trunk_col": "trunk color",
    "leaf_nor": "leaf normal",
    "trunk_nor": "trunk normal",
    "mask": "mask",
}

INPUT_NAMES = {
    # general
    "ignore": "_internal_",
    # slot node
    "seed": "Seed",
    "show viewport": "Show viewport",
    "show render": "Show render",
    "density_attr": "internal_Density field",
    "scale_attr": "internal_Scale field",
    "use_density_attr": "Invert_density_field",
    "use_scale_attr": "Invert_scale_field",
    "invert_density_attr": "Invert_density_field",
    "invert_scale_attr": "Invert_scale_field",
    # control node
    "camera": "cam_Camera",
    "cam_fov": "cam-internal_FOV",
    "cam_res_x": "cam-internal_Resolution X",
    "cam_res_y": "cam-internal_Resolution Y",
    # "use_clipping": "use_camera_clipping",
    "padding": "cam_Padding",
    "collection": "internal_tree_collection",
    "density": "scatter_Density",
    "scale": "scatter_Scale",
    "scale_randomness": "scatter_Scale randomness",
    "viewport_percentage": "scatter_Viewport amount",
    "tilt_randomness": "scatter_Tilt randomness",
    # tree node
    "tree_show_render": "internal_Show render",
    "tree_scale": "tree_Scale",
    "tree_width": "tree_Width",
    "tree_z_offset": "tree_Z offset",
    # single tree node
    "single_tree_cam": "tree_Camera",
    "single_tree_obj": "internal_Tree_obj",
}

WL_LAYER_NAMES = {k: v.upper() for k, v in LAYER_TYPES.items()}

VGROUP_PRESETS = {
    "slope": [{
        "type": WL_LAYER_NAMES["slope"]
    },],
    "height": [{
        "type": WL_LAYER_NAMES["height"]
    },],
    "mesh_proximity": [{
        "type": WL_LAYER_NAMES["proximity_mesh"]
    },],
    "point_proximity": [{
        "type": WL_LAYER_NAMES["proximity_point"]
    },],
    "procedural_texture": [{
        "type": WL_LAYER_NAMES["tex"]
    },],
}

AT_LAYER_NAMES = {
    "input": "AT input",
    "output": "AT output",
}